part of xwidgetbase;

class XfxElencoItem extends StatefulWidget {
  XfxElencoItem({
    Key? key,
    this.childMain,
    this.childDetails,
    this.showingDetails = false,
    this.showMainWithDetails = true,
    this.decorationBackGroundContainer,
    this.changeStatoWithTap = true,
    this.onTapItem,
    this.onLongTapItem,
    this.onDoubleTapItem,
    this.margin,
    this.crossAxisAlignment,
    this.backGroundColor_ChildMain,
    this.colorIcon_Collapsed,
    this.colorIcon_Expanded,
    this.colorText_Collapsed,
    this.colorText_Expanded,
  }) : super(key: key);

  /// default TRUE
  bool showMainWithDetails;
  Widget? childMain;
  bool showingDetails;
  Widget? childDetails;
  bool? changeStatoWithTap;
  Color? backGroundColor_ChildMain;
  Color? colorIcon_Expanded;
  Color? colorIcon_Collapsed;
  Color? colorText_Expanded;
  Color? colorText_Collapsed;
  Decoration? decorationBackGroundContainer;
  EdgeInsetsGeometry? margin;
  CrossAxisAlignment? crossAxisAlignment;
  Function()? onTapItem;
  Function()? onLongTapItem;
  Function()? onDoubleTapItem;
  @override
  _XfxElencoItemState createState() => _XfxElencoItemState();
}

class _XfxElencoItemState extends State<XfxElencoItem> {
  Widget xBuilder_childMain() {
    return widget.childMain ?? Container();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: widget.onTapItem ??
            () {
              if (widget.changeStatoWithTap == true) {
                setState(() {
                  widget.showingDetails = !widget.showingDetails;
                });
              }
            },
        onLongPress: widget.onLongTapItem ?? () {},
        onDoubleTap: widget.onDoubleTapItem ?? () {},
        child: Container(
            decoration: widget.decorationBackGroundContainer ?? BoxDecoration(color: Colors.grey[900]),
            margin: widget.margin ?? EdgeInsets.only(bottom: 2),
            child: Column(crossAxisAlignment: widget.crossAxisAlignment ?? CrossAxisAlignment.center, children: [
              (widget.showMainWithDetails == false && widget.showingDetails == true)
                  ? Container()
                  : Row(children: [
                      Expanded(
                          child: Container(
                        padding: EdgeInsets.all(5),
                        color: widget.backGroundColor_ChildMain,
                        child: xBuilder_childMain(),
                      )),
                      Icon(
                        widget.showingDetails ? Icons.keyboard_arrow_up_outlined : Icons.keyboard_arrow_down_outlined,
                        color: (widget.showingDetails == false) ? widget.colorIcon_Collapsed ?? Colors.grey : widget.colorIcon_Expanded ?? Colors.yellow,
                        size: 28,
                      )
                    ]),
              Row(children: [
                ((widget.showingDetails == true) ? widget.childDetails! : Container()),
              ]),
            ])));
  }
}
